diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_admin.c ircd-hybrid-7-bg/modules/m_admin.c
--- ircd-hybrid-7rc5/modules/m_admin.c	Wed Jul 31 12:24:06 2002
+++ ircd-hybrid-7-bg/modules/m_admin.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_admin.c,v 1.35 2002/07/31 16:24:06 leeh Exp $
+ *  $Id: m_admin.c,v 1.3 2003/05/24 00:07:44 demond Exp $
  */
 
 #include "stdinc.h"
@@ -34,6 +34,7 @@
 #include "parse.h"
 #include "hook.h"
 #include "modules.h"
+#include "s_misc.h"
 
 static void m_admin(struct Client*, struct Client*, int, char**);
 static void mr_admin(struct Client*, struct Client*, int, char**);
@@ -60,7 +61,7 @@
   hook_del_event("doing_admin");
   mod_del_cmd(&admin_msgtab);
 }
-const char *_version = "$Revision: 1.35 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mr_admin - ADMIN command handler
@@ -74,7 +75,7 @@
  
   if((last_used + ConfigFileEntry.pace_wait) > CurrentTime)
     {
-      sendto_one(source_p,form_str(RPL_LOAD2HI), me.name, 
+      sendto_one(source_p,form_str(source_p,RPL_LOAD2HI), me.name, 
                  BadPtr(parv[0]) ? "*" : parv[0]);
       return;
     }
@@ -96,7 +97,7 @@
 
   if((last_used + ConfigFileEntry.pace_wait) > CurrentTime)
     {
-      sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,parv[0]);
+      sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,parv[0]);
       return;
     }
   else
@@ -120,6 +121,8 @@
 static void ms_admin(struct Client *client_p, struct Client *source_p,
                     int parc, char *parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if (hunt_server(client_p,source_p,":%s ADMIN :%s",1,parc,parv) != HUNTED_ISME)
     return;
 
@@ -145,16 +148,16 @@
 
   nick = BadPtr(source_p->name) ? "*" : source_p->name;
 
-  sendto_one(source_p, form_str(RPL_ADMINME),
+  sendto_one(source_p, form_str(source_p,RPL_ADMINME),
 	     me.name, nick, me.name);
   if (AdminInfo.name != NULL)
-    sendto_one(source_p, form_str(RPL_ADMINLOC1),
+    sendto_one(source_p, form_str(source_p,RPL_ADMINLOC1),
 	       me.name, nick, AdminInfo.name);
   if (AdminInfo.description != NULL)
-    sendto_one(source_p, form_str(RPL_ADMINLOC2),
+    sendto_one(source_p, form_str(source_p,RPL_ADMINLOC2),
 	       me.name, nick, AdminInfo.description);
   if (AdminInfo.email != NULL)
-    sendto_one(source_p, form_str(RPL_ADMINEMAIL),
+    sendto_one(source_p, form_str(source_p,RPL_ADMINEMAIL),
 	       me.name, nick, AdminInfo.email);
 }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_away.c ircd-hybrid-7-bg/modules/m_away.c
--- ircd-hybrid-7rc5/modules/m_away.c	Wed Jul 31 12:24:06 2002
+++ ircd-hybrid-7-bg/modules/m_away.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_away.c,v 1.31 2002/07/31 16:24:06 leeh Exp $
+ *  $Id: m_away.c,v 1.3 2003/05/24 00:07:44 demond Exp $
  */
 
 #include "stdinc.h"
@@ -35,7 +35,7 @@
 #include "s_conf.h"
 #include "s_serv.h"
 #include "packet.h"
-
+#include "s_misc.h"
 
 static void m_away(struct Client*, struct Client*, int, char**);
 
@@ -55,7 +55,7 @@
 {
   mod_del_cmd(&away_msgtab);
 }
-const char *_version = "$Revision: 1.31 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /***********************************************************************
  * m_away() - Added 14 Dec 1988 by jto. 
@@ -79,6 +79,9 @@
                   char *parv[])
 {
   char  *away, *awy2 = parv[1];
+  
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  awy2 = parv[1];
 
   if(MyClient(source_p) && !IsFloodDone(source_p))
     flood_endgrace(source_p);
@@ -103,7 +106,7 @@
           source_p->user->away = NULL;
         }
       if (MyConnect(source_p))
-        sendto_one(source_p, form_str(RPL_UNAWAY),
+        sendto_one(source_p, form_str(source_p,RPL_UNAWAY),
                    me.name, parv[0]);
       return;
     }
@@ -113,7 +116,7 @@
   if (MyConnect(source_p) && !IsOper(source_p) &&
      (CurrentTime-source_p->user->last_away)<ConfigFileEntry.pace_wait)
     {
-      sendto_one(source_p, form_str(RPL_LOAD2HI), me.name, parv[0]);
+      sendto_one(source_p, form_str(source_p,RPL_LOAD2HI), me.name, parv[0]);
       return;
     }
 
@@ -139,6 +142,6 @@
   source_p->user->away = away;
 
   if (MyConnect(source_p))
-    sendto_one(source_p, form_str(RPL_NOWAWAY), me.name, parv[0]);
+    sendto_one(source_p, form_str(source_p,RPL_NOWAWAY), me.name, parv[0]);
 }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_capab.c ircd-hybrid-7-bg/modules/m_capab.c
--- ircd-hybrid-7rc5/modules/m_capab.c	Fri May 24 19:34:19 2002
+++ ircd-hybrid-7-bg/modules/m_capab.c	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_capab.c,v 1.28 2002/05/24 23:34:19 androsyn Exp $
+ *  $Id: m_capab.c,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #include "stdinc.h"
@@ -51,7 +51,7 @@
   mod_del_cmd(&capab_msgtab);
 }
 
-const char *_version = "$Revision: 1.28 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 
 /*
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_cburst.c ircd-hybrid-7-bg/modules/m_cburst.c
--- ircd-hybrid-7rc5/modules/m_cburst.c	Fri May 24 19:34:19 2002
+++ ircd-hybrid-7-bg/modules/m_cburst.c	Mon Mar 10 01:09:00 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_cburst.c,v 1.41 2002/05/24 23:34:19 androsyn Exp $
+ *  $Id: m_cburst.c,v 1.2 2003/03/10 06:09:00 demond Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
   mod_del_cmd(&cburst_msgtab);
 }
 
-const char *_version = "$Revision: 1.41 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
 ** m_cburst
@@ -119,7 +119,7 @@
     }
     else if(nick && *nick=='!')
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
                  me.name, nick+1, name);
       return;
     }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_challenge.c ircd-hybrid-7-bg/modules/m_challenge.c
--- ircd-hybrid-7rc5/modules/m_challenge.c	Sun Oct 27 20:08:40 2002
+++ ircd-hybrid-7-bg/modules/m_challenge.c	Mon Mar 10 01:09:00 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_challenge.c,v 1.38 2002/10/28 01:08:40 gregp Exp $
+ *  $Id: m_challenge.c,v 1.2 2003/03/10 06:09:00 demond Exp $
  */
 
 #include "stdinc.h"
@@ -55,7 +55,7 @@
   return;
 }
 
-const char *_version = "$Revision: 1.38 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 #else
 
@@ -80,7 +80,7 @@
   mod_del_cmd(&challenge_msgtab);
 }
 
-const char *_version = "$Revision: 1.38 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * m_challenge - generate RSA challenge for wouldbe oper
@@ -100,7 +100,7 @@
   /* if theyre an oper, reprint oper motd and ignore */
   if(IsOper(source_p))
   {
-    sendto_one(source_p, form_str(RPL_YOUREOPER), me.name, parv[0]);
+    sendto_one(source_p, form_str(source_p,RPL_YOUREOPER), me.name, parv[0]);
     SendMessageFile(source_p, &ConfigFileEntry.opermotd);
     return;
   }
@@ -113,14 +113,14 @@
      
     if (irccmp(source_p->user->response, ++parv[1]))
     {
-      sendto_one(source_p, form_str(ERR_PASSWDMISMATCH), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_PASSWDMISMATCH), me.name,
 		 source_p->name);
       return;
     }
      
     if (!(aconf = find_conf_by_name(source_p->user->auth_oper, CONF_OPERATOR)))
     {
-      sendto_one (source_p, form_str(ERR_NOOPERHOST), me.name, parv[0]);
+      sendto_one (source_p, form_str(source_p,ERR_NOOPERHOST), me.name, parv[0]);
       log_failed_oper(source_p, source_p->user->auth_oper);
       return;
     }
@@ -166,7 +166,7 @@
                                 source_p->localClient->sockhost,
                                 CONF_OPERATOR)))
   {
-    sendto_one (source_p, form_str(ERR_NOOPERHOST), me.name, parv[0]);
+    sendto_one (source_p, form_str(source_p,ERR_NOOPERHOST), me.name, parv[0]);
     /* they suck, do we tell the world? */
     if (ConfigFileEntry.failed_oper_notice)
     {
@@ -188,7 +188,7 @@
    !generate_challenge (&challenge, &(source_p->user->response), aconf->rsa_public_key)
      )
   {
-    sendto_one (source_p, form_str(RPL_RSACHALLENGE), me.name, parv[0],
+    sendto_one (source_p, form_str(source_p,RPL_RSACHALLENGE), me.name, parv[0],
 		challenge);
   }
   DupString(source_p->user->auth_oper, aconf->name);
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_cjoin.c ircd-hybrid-7-bg/modules/m_cjoin.c
--- ircd-hybrid-7rc5/modules/m_cjoin.c	Thu Aug 15 11:00:59 2002
+++ ircd-hybrid-7-bg/modules/m_cjoin.c	Mon Mar 10 01:09:00 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_cjoin.c,v 1.55 2002/08/15 15:00:59 adx Exp $
+ *  $Id: m_cjoin.c,v 1.2 2003/03/10 06:09:00 demond Exp $
  */
 
 #include "stdinc.h"
@@ -69,7 +69,7 @@
 #endif
 }
 
-const char *_version = "$Revision: 1.55 $";
+const char *_version = "$Revision: 1.2 $";
 #endif /* STATIC_MODULES */
 
 #ifdef VCHANS
@@ -99,21 +99,21 @@
 
   if(ConfigChannel.use_vchans == 0)
   {
-    sendto_one(source_p, form_str(ERR_VCHANDISABLED),
+    sendto_one(source_p, form_str(source_p,ERR_VCHANDISABLED),
                me.name, parv[0]);
     return;
   }
   
   if (ConfigChannel.vchans_oper_only && !IsOper(source_p))
   {
-    sendto_one(source_p, form_str(ERR_NOPRIVILEGES),
+    sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),
                me.name, parv[0]);
     return;
   }
 
   if (*parv[1] == '\0')
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "CJOIN");
       return;
     }
@@ -135,21 +135,21 @@
 
   if (!check_channel_name(name))
     {
-      sendto_one(source_p, form_str(ERR_BADCHANNAME),
+      sendto_one(source_p, form_str(source_p,ERR_BADCHANNAME),
 		 me.name, parv[0], (unsigned char*) name);
       return;
     }
 
   if (*name == '&')
     {
-      sendto_one(source_p, form_str(ERR_BADCHANNAME),
+      sendto_one(source_p, form_str(source_p,ERR_BADCHANNAME),
 		 me.name, parv[0], (unsigned char*) name);
       return;
     }
 
   if (!IsChannelName(name))
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
 		 me.name, parv[0], name);
       return;
     }
@@ -175,7 +175,7 @@
         }
       else
         {
-          sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+          sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
                      me.name, source_p->name, name);
         }
       return;
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_close.c ircd-hybrid-7-bg/modules/m_close.c
--- ircd-hybrid-7rc5/modules/m_close.c	Thu Sep  5 02:05:40 2002
+++ ircd-hybrid-7-bg/modules/m_close.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_close.c,v 1.24 2002/09/05 06:05:40 db Exp $
+ *  $Id: m_close.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -54,7 +54,7 @@
   mod_del_cmd(&close_msgtab);
 }
 
-const char *_version = "$Revision: 1.24 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * mo_close - CLOSE message handler
@@ -81,11 +81,11 @@
           !IsHandshake(target_p) && !IsDoingKauth(target_p))
         continue;
 #endif
-      sendto_one(source_p, form_str(RPL_CLOSING), me.name, parv[0],
+      sendto_one(source_p, form_str(source_p,RPL_CLOSING), me.name, parv[0],
                  get_client_name(target_p, SHOW_IP), target_p->status);
       (void)exit_client(target_p, target_p, target_p, "Oper Closing");
       closed++;
     }
-  sendto_one(source_p, form_str(RPL_CLOSEEND), me.name, parv[0], closed);
+  sendto_one(source_p, form_str(source_p,RPL_CLOSEEND), me.name, parv[0], closed);
 }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_conf.c ircd-hybrid-7-bg/modules/m_conf.c
--- ircd-hybrid-7rc5/modules/m_conf.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-7-bg/modules/m_conf.c	Sat May 24 23:27:10 2003
@@ -0,0 +1,184 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_conf.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_conf.c,v 1.5 2003/05/24 00:07:44 demond Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "s_log.h"
+#include "s_misc.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void ms_conf(struct Client*, struct Client*, int, char**);
+
+struct Message conf_msgtab = {
+  "CONF", 0, 0, 2, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_conf, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&conf_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&conf_msgtab);
+}
+
+const char *_version = "$Revision: 1.5 $";
+#endif
+/*
+ * ms_conf - CONF command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = target server mask
+ *      parv[2] = general variable
+ *		parv[3] = new value
+ */
+static void ms_conf(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+	char buf[BUFMAX];
+	
+	if (ServerInfo.gateway && get_bridge_token(client_p))
+		return;
+
+	ConfigFileEntry.sframe = (long)buf;
+  if (parc < 3)
+    {
+      sendto_server(client_p, source_p, NULL, CAP_SVS, NOCAPS, LL_ICLIENT, 
+      				":%s CONF %s", parv[0], parv[1]);
+
+	  if (match(parv[1], me.name)) {
+		if (!find_z_conf(parv[0]))
+			return;
+
+		sendto_realops_flags(FLAGS_ALL, L_ADMIN,
+			"%s is remotely rehashing server config file", parv[0]);
+		ilog(L_NOTICE, "Remote REHASH from %s", parv[0]);
+
+		rehash(0);
+	  }
+
+      return;
+    }
+
+  if (parc < 4)
+    return;
+
+  sendto_server(client_p, source_p, NULL, CAP_SVS, NOCAPS, LL_ICLIENT,
+				":%s CONF %s %s %s :%s", parv[0], parv[1], parv[2],
+				parc > 4? parv[3] : "", parc > 4? parv[4] : parv[3]);
+
+  if (!match(parv[1], me.name))
+	return;
+  if (!find_z_conf(parv[0]))
+	return;
+
+  if (!irccmp(parv[2], "hide_server")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.hide_server = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.hide_server = 0;
+
+  } else if (!irccmp(parv[2], "netid")) {
+
+	/*strncpy(buf, parv[3], BUFFMAX);*/
+	strncpy(ConfigFileEntry.netid, parv[3],
+	      MAXNETID)[MAXNETID] = 0;
+
+  } else if (!irccmp(parv[2], "cyrillic")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.cyrillic = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.cyrillic = 0;
+
+  } else if (!irccmp(parv[2], "totaltrans")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.totaltrans = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.totaltrans = 0;
+
+  } else if (!irccmp(parv[2], "grace_time")) {
+
+	ConfigFileEntry.grace_time = atoi(parv[3]);		
+
+  } else if (!irccmp(parv[2], "spam_wait")) {
+
+	ConfigFileEntry.spam_wait = atoi(parv[3]);		
+
+  } else if (!irccmp(parv[2], "spawn")) {
+
+	  do_spawn(atoi(parv[3]), parc > 4? parv[4] : NULL);	
+
+  } else if (!irccmp(parv[2], "plugin")) {
+
+	  do_plugin(parv[3], parc > 4? parv[4] : NULL);	
+
+#ifndef STATIC_MODULES
+
+  } else if (!irccmp(parv[2], "modunload")) {
+
+	  unload_one_module(parv[3], 0);	
+
+  } else if (!irccmp(parv[2], "modload")) {
+
+	  char *m_bn = irc_basename(parv[3]);
+
+	  if (findmodule_byname(m_bn) == -1)
+		load_a_module(parv[3], 0, 0);
+	  
+	  MyFree(m_bn);
+	  
+#endif	  
+
+  } else if (!irccmp(parv[2], "drone_kline")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.drone_kline = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.drone_kline = 0;
+
+  } else if (!irccmp(parv[2], "drone_batch")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.drone_batch = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.drone_batch = 0;
+
+  }
+}
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_connect.c ircd-hybrid-7-bg/modules/m_connect.c
--- ircd-hybrid-7rc5/modules/m_connect.c	Thu Sep 19 12:14:33 2002
+++ ircd-hybrid-7-bg/modules/m_connect.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_connect.c,v 1.38 2002/09/19 16:14:33 bill Exp $
+ *  $Id: m_connect.c,v 1.3 2003/05/24 00:07:44 demond Exp $
  */
 
 #include "stdinc.h"
@@ -61,7 +61,7 @@
   mod_del_cmd(&connect_msgtab);
 }
 
-const char *_version = "$Revision: 1.38 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mo_connect - CONNECT command handler
@@ -98,7 +98,7 @@
 
   if (*parv[1] == '\0')
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "CONNECT");
       return;
     }
@@ -202,6 +202,9 @@
   struct ConfItem* aconf;
   struct Client*   target_p;
 
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
+
   if (hunt_server(client_p, source_p,
                   ":%s CONNECT %s %s :%s", 3, parc, parv) != HUNTED_ISME)
     {
@@ -210,7 +213,7 @@
 
   if (*parv[1] == '\0')
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "CONNECT");
       return;
     }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_cryptlink.c ircd-hybrid-7-bg/modules/m_cryptlink.c
--- ircd-hybrid-7rc5/modules/m_cryptlink.c	Sat Oct 12 06:39:04 2002
+++ ircd-hybrid-7-bg/modules/m_cryptlink.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_cryptlink.c,v 1.35 2002/10/12 10:39:04 db Exp $
+ *  $Id: m_cryptlink.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 /*
@@ -68,7 +68,7 @@
 void _modinit(void) {}
 void _moddeinit(void) {}
 
-const char *_version = "$Revision: 1.35 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 #else
 
@@ -114,7 +114,7 @@
   mod_del_cmd(&cryptlink_msgtab);
 }
 
-const char *_version = "$Revision: 1.35 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_dmem.c ircd-hybrid-7-bg/modules/m_dmem.c
--- ircd-hybrid-7rc5/modules/m_dmem.c	Fri May 24 19:34:19 2002
+++ ircd-hybrid-7-bg/modules/m_dmem.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_dmem.c,v 1.15 2002/05/24 23:34:19 androsyn Exp $
+ *  $Id: m_dmem.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
@@ -59,7 +59,7 @@
   mod_del_cmd(&dmem_msgtab);
 }
 
-const char *_version = "$Revision: 1.15 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 #ifdef MEMDEBUG
 void ReportAllocated(struct Client*);
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_drop.c ircd-hybrid-7-bg/modules/m_drop.c
--- ircd-hybrid-7rc5/modules/m_drop.c	Fri May 24 19:34:19 2002
+++ ircd-hybrid-7-bg/modules/m_drop.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_drop.c,v 1.24 2002/05/24 23:34:19 androsyn Exp $
+ *  $Id: m_drop.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
   mod_del_cmd(&drop_msgtab);
 }
 
-const char *_version = "$Revision: 1.24 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 /*
 ** ms_drop
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_eob.c ircd-hybrid-7-bg/modules/m_eob.c
--- ircd-hybrid-7rc5/modules/m_eob.c	Fri May 24 19:34:19 2002
+++ ircd-hybrid-7-bg/modules/m_eob.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_eob.c,v 1.31 2002/05/24 23:34:19 androsyn Exp $
+ *  $Id: m_eob.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
@@ -54,7 +54,7 @@
   mod_del_cmd(&eob_msgtab);
 }
 
-const char *_version = "$Revision: 1.31 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 /*
  * ms_eob - EOB command handler
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_gline.c ircd-hybrid-7-bg/modules/m_gline.c
--- ircd-hybrid-7rc5/modules/m_gline.c	Wed Sep  4 22:48:41 2002
+++ ircd-hybrid-7-bg/modules/m_gline.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_gline.c,v 1.84 2002/09/05 02:48:41 db Exp $
+ *  $Id: m_gline.c,v 1.2 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -109,7 +109,7 @@
   mod_del_cmd(&gline_msgtab);
 }
 
-const char *_version = "$Revision: 1.84 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * mo_gline()
@@ -273,6 +273,9 @@
   char *host = NULL;             /* user and host of GLINE "victim" */
   const char *reason = NULL;           /* reason for "victims" demise */
   struct Client *acptr;
+  
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
 
   /* hyb-7 style gline (post beta3) */
   if(parc == 4 && IsPerson(source_p))
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_help.c ircd-hybrid-7-bg/modules/m_help.c
--- ircd-hybrid-7rc5/modules/m_help.c	Wed Jul 17 18:02:34 2002
+++ ircd-hybrid-7-bg/modules/m_help.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_help.c,v 1.34 2002/07/17 22:02:34 db Exp $
+ *  $Id: m_help.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -67,7 +67,7 @@
   mod_del_cmd(&uhelp_msgtab);
 }
 
-const char *_version = "$Revision: 1.34 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * m_help - HELP message handler
@@ -85,7 +85,7 @@
     if ((last_used + ConfigFileEntry.pace_wait_simple) > CurrentTime)
     {
       /* safe enough to give this on a local connect only */
-      sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,parv[0]);
+      sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,parv[0]);
         return;
     }
     else
@@ -155,13 +155,13 @@
 
   if (strchr(topic, '/'))
   {
-    sendto_one(source_p, form_str(ERR_HELPNOTFOUND), me.name, nick, topic);
+    sendto_one(source_p, form_str(source_p,ERR_HELPNOTFOUND), me.name, nick, topic);
     return;
   }
 
   if (strlen(hpath) + strlen(topic) + 1 > MAXPATHLEN)
   {
-    sendto_one(source_p, form_str(ERR_HELPNOTFOUND), me.name, nick, topic);
+    sendto_one(source_p, form_str(source_p,ERR_HELPNOTFOUND), me.name, nick, topic);
     return;
   }
 
@@ -170,14 +170,14 @@
   if (stat(path, &sb) < 0)
   {
     ilog(L_NOTICE, "help file %s not found", path);
-    sendto_one(source_p, form_str(ERR_HELPNOTFOUND), me.name, nick, topic);
+    sendto_one(source_p, form_str(source_p,ERR_HELPNOTFOUND), me.name, nick, topic);
     return;
   }
 
   if (!S_ISREG(sb.st_mode))
   {
     ilog(L_NOTICE, "help file %s not found", path);
-    sendto_one(source_p, form_str(ERR_HELPNOTFOUND), me.name, nick, topic);
+    sendto_one(source_p, form_str(source_p,ERR_HELPNOTFOUND), me.name, nick, topic);
     return;
   }
 
@@ -194,24 +194,24 @@
 
   if ((file = fbopen(path, "r")) == NULL)
   {
-    sendto_one(source_p, form_str(ERR_HELPNOTFOUND), me.name, nick, topic);
+    sendto_one(source_p, form_str(source_p,ERR_HELPNOTFOUND), me.name, nick, topic);
     return;
   }
 
   if (fbgets(line, sizeof(line), file) == NULL)
   {
-    sendto_one(source_p, form_str(ERR_HELPNOTFOUND), me.name, nick, topic);
+    sendto_one(source_p, form_str(source_p,ERR_HELPNOTFOUND), me.name, nick, topic);
     return;
   }
 
-  sendto_one(source_p, form_str(RPL_HELPSTART), me.name, nick, topic, line);
+  sendto_one(source_p, form_str(source_p,RPL_HELPSTART), me.name, nick, topic, line);
 
   while (fbgets(line, sizeof(line), file))
   {
-    sendto_one(source_p, form_str(RPL_HELPTXT), me.name, nick, topic, line);
+    sendto_one(source_p, form_str(source_p,RPL_HELPTXT), me.name, nick, topic, line);
   }
 
-  sendto_one(source_p, form_str(RPL_ENDOFHELP), me.name, nick, topic);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFHELP), me.name, nick, topic);
   return;
 }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_info.c ircd-hybrid-7-bg/modules/m_info.c
--- ircd-hybrid-7rc5/modules/m_info.c	Mon Oct 28 16:09:21 2002
+++ ircd-hybrid-7-bg/modules/m_info.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_info.c,v 1.61 2002/10/28 21:09:21 bill Exp $
+ *  $Id: m_info.c,v 1.5 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -40,6 +40,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
+#include "s_misc.h"
 
 static void send_conf_options(struct Client *source_p);
 static void send_birthdate_online_time(struct Client *source_p);
@@ -69,7 +70,7 @@
   hook_del_event("doing_info");
   mod_del_cmd(&info_msgtab);
 }
-const char *_version = "$Revision: 1.61 $";
+const char *_version = "$Revision: 1.5 $";
 #endif
 
 /*
@@ -89,6 +90,7 @@
 #define OUTPUT_BOOLEAN     0x0008   /* Output option as "ON" or "OFF" */
 #define OUTPUT_BOOLEAN_YN  0x0010   /* Output option as "YES" or "NO" */
 #define OUTPUT_BOOLEAN2	   0x0020   /* Output option as "YES/NO/MASKED" */
+#define OUTPUT_POINTER     0x0040   
 
 static struct InfoStruct info_table[] =
 {
@@ -148,6 +150,12 @@
     "Inform opers if someone /oper's with the wrong password"
   },
   {
+    "sframe",
+    OUTPUT_POINTER,
+    &ConfigFileEntry.sframe,
+    "Stack frame info"
+  },
+  {
     /* fname_operlog is a char [] */
     "fname_operlog",
     OUTPUT_STRING_PTR,
@@ -421,6 +429,18 @@
     "Enable chanmode +I (invite exceptions)",
   },
   {
+    "use_subst",
+    OUTPUT_BOOLEAN_YN,
+    &ConfigChannel.use_subst,
+    "Enable chanmode +w (word substitutions)",
+  },
+  {
+    "use_denies",
+    OUTPUT_BOOLEAN_YN,
+    &ConfigChannel.use_denies,
+    "Enable chanmode +d (gecos & channame deny bans)",
+  },
+  {
     "use_knock",
     OUTPUT_BOOLEAN_YN,
     &ConfigChannel.use_knock,
@@ -506,7 +526,7 @@
   if ((last_used + ConfigFileEntry.pace_wait) > CurrentTime)
   {
     /* safe enough to give this on a local connect only */
-    sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,parv[0]);
+    sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,parv[0]);
     return;
   }
   else
@@ -528,7 +548,7 @@
   send_info_text(source_p);
   send_birthdate_online_time(source_p);
 
-  sendto_one(source_p, form_str(RPL_ENDOFINFO), me.name, parv[0]);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFINFO), me.name, parv[0]);
 
 } /* m_info() */
 
@@ -549,7 +569,7 @@
     send_conf_options(source_p);
     send_birthdate_online_time(source_p);
 
-    sendto_one(source_p, form_str(RPL_ENDOFINFO), me.name, parv[0]);
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFINFO), me.name, parv[0]);
   }
 } /* mo_info() */
 
@@ -562,6 +582,8 @@
                    int parc, char *parv[])
 
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if(!IsClient(source_p))
       return;
   
@@ -574,7 +596,7 @@
       send_conf_options(source_p);
       
     send_birthdate_online_time(source_p);
-    sendto_one(source_p, form_str(RPL_ENDOFINFO),
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFINFO),
                me.name, parv[0]);
   }
 } /* ms_info() */
@@ -593,10 +615,10 @@
 
   while (*text)
   {
-    sendto_one(source_p, form_str(RPL_INFO), me.name, source_p->name, *text++);
+    sendto_one(source_p, form_str(source_p,RPL_INFO), me.name, source_p->name, *text++);
   }
 
-  sendto_one(source_p, form_str(RPL_INFO), me.name, source_p->name, "");
+  sendto_one(source_p, form_str(source_p,RPL_INFO), me.name, source_p->name, "");
 }
 
 /*
@@ -710,6 +732,24 @@
          break;
        }
        /*
+        * raw pointer value
+        */
+       case OUTPUT_POINTER:
+       {
+         long option = *((long *) info_table[i].option);
+
+         sendto_one(source_p,
+           ":%s %d %s :%-25s %-10p [%-30s]",
+           me.name,
+           RPL_INFO,
+           source_p->name,
+           info_table[i].name,
+           option ? (void *)option : NULL,
+           info_table[i].desc ? info_table[i].desc : "<none>");
+
+         break;
+       }
+       /*
         * Output info_table[i].option as a decimal value.
         */
        case OUTPUT_DECIMAL:
@@ -774,7 +814,9 @@
 
 #ifndef EFNET
   /* jdc -- Only send compile information to admins. */
-  if (IsOperAdmin(source_p))
+  /*if (IsOperAdmin(source_p))*/
+  /* ...to remote admins too... -demond */
+  if (IsAdmin(source_p))
   {
     sendto_one(source_p,
 	":%s %d %s :Compiled on [%s]",
@@ -785,7 +827,7 @@
   }
 #endif
 
-  sendto_one(source_p, form_str(RPL_INFO), me.name, source_p->name, "");
+  sendto_one(source_p, form_str(source_p,RPL_INFO), me.name, source_p->name, "");
 }
 
 /* info_spy()
